<template>
  <MainTemplate>
    <template #topBar>
      <div class="flex flex-row items-center justify-between pt-5 pb-3 px-7">
        <h1 class="font-bold text-xl h-8">Termintyp</h1>
      </div>
    </template>
    <template #diffMain>
      <div class="flex flex-col gap-4 h-full pl-7">
        <div class="flex flex-col gap-2 grow overflow-y-scroll pr-7">
          <CalendarTypeListItem
            v-for="calendarType in calendarTypes"
            :key="calendarType.id"
            :calendarType="calendarType"
          />
        </div>
        <div class="flex flex-row gap-4">
          <button v-if="can('create', 'settings', 'calendar_type')" primary class="!w-fit" @click="openCreateModal">
            Termintyp erstellen
          </button>
        </div>
      </div>
    </template>
  </MainTemplate>
</template>

<script setup lang="ts">
import { defineComponent, defineAsyncComponent, markRaw } from "vue";
import { mapState, mapActions } from "pinia";
import MainTemplate from "@/templates/Main.vue";
import { useCalendarTypeStore } from "@/stores/admin/settings/calendarType";
import CalendarTypeListItem from "@/components/admin/settings/calendarType/CalendarTypeListItem.vue";
import { useModalStore } from "@/stores/modal";
import { useAbilityStore } from "@/stores/ability";
</script>

<script lang="ts">
export default defineComponent({
  computed: {
    ...mapState(useCalendarTypeStore, ["calendarTypes"]),
    ...mapState(useAbilityStore, ["can"]),
  },
  mounted() {
    this.fetchCalendarTypes();
  },
  methods: {
    ...mapActions(useCalendarTypeStore, ["fetchCalendarTypes"]),
    ...mapActions(useModalStore, ["openModal"]),
    openCreateModal() {
      this.openModal(
        markRaw(
          defineAsyncComponent(() => import("@/components/admin/settings/calendarType/CreateCalendarTypeModal.vue"))
        )
      );
    },
  },
});
</script>
